//Attribute Position3F_TexCoord2F_Color4B

//TechniqueParameter vec3 _fadeoutCenter //Default 0.0f, 0.0f, 10.0f

uniform mat4 uModelViewProjectionMatrix;
uniform float uHueShift;      //Default 0.0f
uniform float uHueShiftOuter; //Default 0.05f
uniform float uHueMultiplier; //Default 1.0f
uniform float uInvert;        //Default 0.0f

//CalculatedMaterial
uniform vec3 uFadeoutCenter; //Calculate _fadeoutCenter

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec3 vOuterColor;
varying float vInvert;

vec3 rgb(float h) { return clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0); }

void main()
{
    //AttributeMapping
    //aColor.r => Hue
    //aColor.g => UNUSED
    //aColor.b => DefaultInvert
    //aColor.a => UseInvertUniform
    float hueInner = aColor.r * uHueMultiplier + uHueShift;
    vTexCoord = aTexCoord;
    vInvert = abs(aColor.b - aColor.a * uInvert);
    vInnerColor = rgb(hueInner);
    vOuterColor = rgb(hueInner + uHueShiftOuter);
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition.xy, aPosition.z * clamp(0.2*(uFadeoutCenter.z-length(aPosition.xy - uFadeoutCenter.xy)), 0.0, 1.0), 1.0);
}
