//Attribute Position3F_TexCoord2F_Color4B

//TechniqueParameter vec3 _avatarPosition //Default 0.0f, 0.0f, 0.0f
//TechniqueParameter vec3 _fadeoutCenter //Default 0.0f, 0.0f, 10.0f

uniform mat4 uModelViewProjectionMatrix;
uniform float uHueShift;      //Default 0.0f
uniform float uHueShiftOuter; //Default 0.05f
uniform float uHueMultiplier; //Default 1.0f
uniform float uAvatarDistance; //Default 4.0f
uniform float uAvatarFalloff;  //Default 2.0f

//CalculatedMaterial
uniform vec3 uAvatarPosition; //Calculate _avatarPosition
uniform vec3 uFadeoutCenter; //Calculate _fadeoutCenter

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec3 vOuterColor;
varying float vInvert;

vec3 rgb(float h, float s) { return mix(vec3(1.0), clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0), s); }

void main()
{
    //AttributeMapping
    //aColor.r => Hue
    //aColor.g => Saturation
    //aColor.b => DefaultInvert
    //aColor.a => InvertByAvatarDistance
    float hueInner = aColor.r * uHueMultiplier + uHueShift;
    vTexCoord = aTexCoord;
    vInvert = abs(aColor.b - aColor.a * clamp((length(uAvatarPosition - aPosition) - uAvatarDistance) / uAvatarFalloff, 0.0, 1.0));
    vInnerColor = rgb(hueInner, aColor.g);
    vOuterColor = rgb(hueInner + uHueShiftOuter, aColor.g);
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition.xy, aPosition.z * clamp(0.2*(uFadeoutCenter.z-length(aPosition.xy - uFadeoutCenter.xy)), 0.0, 1.0), 1.0);
}
