uniform sampler2D uTexture;
uniform lowp float uValue;  //Default 1.0f

varying mediump vec2 vTexCoord;
varying lowp vec3 vInnerColor;
varying lowp vec3 vOuterColor;
varying lowp float vInvert;

void main(void)
{
    lowp vec4 sample = texture2D(uTexture, vTexCoord);
    sample.r = mix(sample.r, 1.0 - sample.r, vInvert);
    gl_FragColor = vec4(uValue * (sample.r * mix(vInnerColor, vOuterColor, abs(vInvert - sample.b)) + (1.0 - sample.r) * sample.g * vOuterColor), 1.0);
}

