uniform sampler2D uTexture;
uniform lowp float uValue;  //Default 1.0f
uniform lowp vec3  uColor;  //Default 0.0f, 0.0f, 0.0f

varying mediump vec2 vTexCoord;
varying lowp vec3 vInnerColor;
varying lowp vec3 vOuterColor;
varying lowp float vMix;

void main(void)
{
    lowp vec4 sample = texture2D(uTexture, vTexCoord);
    lowp vec2 invSample = 1.0 - sample.rg;
    gl_FragColor = vec4(uValue * (sample.r * mix(vInnerColor, vOuterColor, sample.b) + invSample.r * sample.g * vOuterColor + invSample.r * invSample.g * vMix * uColor), 1.0);
}

