//Attribute Position3F_TexCoord2F_Color4B

uniform mat4 uModelViewProjectionMatrix;
uniform float uHueShift;      //Default 0.0f
uniform float uHueShiftOuter; //Default 0.05f
uniform float uHueMultiplier; //Default 1.0f
uniform lowp float uMix;      //Default 0.0f

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec3 vOuterColor;
varying float vMix;

vec3 rgb(float h, float s) { return mix(vec3(1.0), clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0), s); }

void main()
{
    float hueInner = aColor.r * uHueMultiplier + uHueShift;
    vTexCoord = aTexCoord;
    vMix = aColor.a * uMix;
    vInnerColor = rgb(hueInner, aColor.g);
    vOuterColor = rgb(hueInner + uHueShiftOuter, aColor.g);
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition, 1.0);
}
