//Attribute Position4F_Normal3F_TexCoord2F_Color4B

//TechniqueParameter mat4 _equalizerHeights //Default 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f

uniform mat4 uModelViewProjectionMatrix;
uniform float uHueShift;      //Default 0.0f
uniform float uHueShiftOuter; //Default 0.05f
uniform float uHueMultiplier; //Default 1.0f
uniform float uBeat;          //Default 0.0f

//CalculatedMaterial
uniform mat4 uEqualizerHeights; //Calculate _equalizerHeights

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec3 vOuterColor;
varying float vInvert;

vec3 rgb(float h) { return clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0); }

void main()
{
    //AttributeMapping
    //aPosition.a => EqualizerBucket
    //aColor.r => Hue
    //aColor.g => AnimationOffset
    //aColor.b => AnimationLength
    //aColor.a => RecalculateTexCoords
    float height = uEqualizerHeights[int(aPosition.a / 4.0)][int(mod(aPosition.a, 4.0))];
    float hueInner = (aColor.r + height) * uHueMultiplier + uHueShift;
    vTexCoord = aTexCoord;
    vTexCoord.y *= (height * aColor.a) + (1.0 - aColor.a);
    vInvert = max(sign(uBeat - aColor.g * 255.0), 0.0) * (1.0 - clamp(uBeat - (aColor.g + aColor.b) * 255.0, 0.0, 1.0));
    vInnerColor = rgb(hueInner);
    vOuterColor = rgb(hueInner + uHueShiftOuter);
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition.xyz + aNormal * height, 1.0);
}
