/*
 Distance field glyph texture has value:
 <0.5 inside the glyph
 =0.5 at the boundary of the glyph
 >0.5 outside the glyph
 */

//#extension GL_OES_standard_derivatives : enable

uniform sampler2D uSamplerFontTexture;     //!< Sampler for the 2D texture access: Main texture.
uniform lowp vec4 uFontColor; //Default 1.0f, 1.0f, 1.0f, 1.0f
uniform lowp vec4 uBoundaryColor; //Default 1.0f, 1.0f, 1.0f, 1.0f
uniform lowp vec4 uParams; //Default 0.45f, 0.5f, 0.6f, 1.0f

varying mediump vec2 vTexCoord;      //!< Interpolated texture coordinate of this fragment

//
/*
const mediump float tFull = 0.5;            //  uParams.x
const mediump float tFullToBoundary = 0.55; //  uParams.y
const mediump float tBoundary = 0.6;        //  uParams.z
*/

// Airborne Pilot
//const mediump float tFull = 0.45;
//const mediump float tFullToBoundary = 0.5;
//const mediump float tBoundary = 0.6;

void main()
{
    mediump float dist = texture2D(uSamplerFontTexture, vTexCoord).r;
//    if (dist>tBoundary) discard;
    
    mediump float t0 = smoothstep(uParams.y, uParams.x, dist);
    mediump float t1 = smoothstep(uParams.z, uParams.y, dist);
    //gl_FragColor = vec4(uFontColor.rgb*t0 + uBoundaryColor.rgb*(1.0-t0) - uBoundaryColor.rgb*(1.0-t1),1.0*t1*uFontColor.w);
    gl_FragColor = uFontColor*t0 + uBoundaryColor*(1.0-t0) - uBoundaryColor*(1.0-t1);
}
