/*
 Distance field glyph texture has value:
 <0.5 inside the glyph
 =0.5 at the boundary of the glyph
 >0.5 outside the glyph
 */

uniform sampler2D uSamplerFontTexture;     //!< Sampler for the 2D texture access: Main texture.

varying mediump vec2 vTexCoord;      //!< Interpolated texture coordinate of this fragment

const mediump float tFull = 0.5;
const mediump float tFullToBoundary = 0.6;
const mediump float tBoundary = 0.7;

void main()
{
    mediump float dist = texture2D(uSamplerFontTexture, vTexCoord).a;
    mediump float t0 = smoothstep(tFull, tFullToBoundary, dist);
    gl_FragColor.r = t0;
    gl_FragColor.b = 1.0 - t0 * smoothstep(tBoundary, tFullToBoundary, dist);
}
