//Attribute Position3F_TexCoord2F

uniform mat4 uModelViewProjectionMatrix;
uniform vec2 uRotationCenter; //Default 0.0f, 0.0f
uniform float uRotation;      //Default 0.0f

varying vec2 vTexCoord;

void main()
{
    vec2 localTexCoord = aTexCoord - uRotationCenter;
    vTexCoord.x = cos(uRotation) * localTexCoord.x - sin(uRotation) * localTexCoord.y + uRotationCenter.x;
    vTexCoord.y = sin(uRotation) * localTexCoord.x + cos(uRotation) * localTexCoord.y + uRotationCenter.y;
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition, 1.0);
}
