uniform sampler2D uTexture;
uniform lowp float uAlpha;

varying mediump vec2 vTexCoord;
varying mediump vec2 vPosition;

void main(void)
{
    lowp vec4 sample = texture2D(uTexture, vTexCoord);
    gl_FragColor = vec4(sample.rgb, max(sample.r, max(sample.g, sample.b)) * sample.a * uAlpha) * clamp(0.5 + 1.5 * max(abs(vPosition.x), abs(vPosition.y)), 0.0, 1.0);
}

