uniform samplerCube uTextureCubeMap;
uniform highp float uScale; // Default 1.0f
uniform highp float uAspect;

varying highp vec2 vTexCoord;

void main()
{
    highp vec2 point = (vTexCoord - 0.5) * vec2(uScale * uAspect, uScale);
    highp float squaredDistance = point.x * point.x + point.y * point.y;
    highp vec3 pointOnSphere = vec3(2.0 * point, squaredDistance - 1.0) / (squaredDistance + 1.0);
    gl_FragColor = textureCube(uTextureCubeMap, pointOnSphere);
}
