uniform samplerCube uTextureCubeMap;
uniform lowp  float uGrayscale; // Default 0.0f
uniform highp float uScale;     // Default 1.0f
uniform highp float uAspect;

varying highp vec2 vTexCoord;

void main()
{
    highp vec2 point = (vTexCoord - 0.5) * vec2(uScale * uAspect, uScale);
    highp float squaredDistance = point.x * point.x + point.y * point.y;
    highp vec3 pointOnSphere = vec3(2.0 * point, squaredDistance - 1.0) / (squaredDistance + 1.0);
    lowp vec4 color = textureCube(uTextureCubeMap, pointOnSphere);
    lowp float gray = 0.299 * color.r + 0.587 * color.g + 0.114 * color.b;
    gl_FragColor = vec4(mix(color.rgb, vec3(gray), uGrayscale), color.a);
}
