uniform samplerCube uTextureCubeMap;
uniform highp float uScale; // Default 1.0f
uniform highp float uAspect;
uniform highp mat3 uTransform;

varying highp vec2 vTexCoord;

void main()
{
    highp vec2 point = (vTexCoord - 0.5) * vec2(uScale * uAspect, uScale);
    highp float squaredDistance = point.x * point.x + point.y * point.y;
    highp vec3 pointOnSphere1 = vec3(2.0 * point, squaredDistance - 1.0) / (squaredDistance + 1.0);
    highp vec3 pointOnSphere2 = uTransform * pointOnSphere1;
    highp vec3 pointOnSphere = normalize(mix(pointOnSphere1, pointOnSphere2, vTexCoord.x));
    gl_FragColor = textureCube(uTextureCubeMap, pointOnSphere);
}
