//Attribute Position3F_Normal3F_TexCoord2F_Color4B_Data4B

//TechniqueParameter double _absoluteDistance //Default 0.0f

uniform mat4  uModelViewProjectionMatrix;
uniform float uHueShift;        //Default 0.0f
uniform float uHueMultiplier;   //Default 1.0f

//CalculatedMaterial
uniform float uAbsoluteDistance; //Calculate _absoluteDistance

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec4 vOuterColor;

const float FULL = 255.0;
const float QUARTER = 63.75;
const float PI2 = 6.28318530718;

vec3 rgb(float h) { return clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0); }

void main()
{
    //AttributeMapping
    //aNormal  => Center
    //aColor.r => Hue
    //aColor.g => HueShiftOuter
    //aColor.b => UNUSED
    //aColor.a => Alpha
    //aData.x  => AnimationQuarterScale
    //aData.y  => AnimationQuarterRotation
    //aData.z  => AnimationQuarterTranslation
    //aData.w  => AnimationLength
    
    vec4 data = QUARTER * vec4(aData.r, aData.g, aData.b, aData.a);
    float t = fract(uAbsoluteDistance / (4.0 * data.w));
    float spike = 1.0 - 2.0 * abs(t - 0.5);
    float angle = t * PI2 * data.y;
    float s = sin(angle);
    float c = cos(angle);
    mat3 rot = mat3(c, s, 0.0, -s, c, 0.0, 0.0, 0.0, 1.0);
    //vec3 position = mix(1.0, data.x, spike) * (rot * (aPosition - aNormal));
    vec3 position = mix(data.x, 1.0, t) * (rot * (aPosition - aNormal));
    position.z += spike * data.z;
    
    vTexCoord = aTexCoord;
    
    float hueInner = aColor.r * uHueMultiplier + uHueShift;
    vInnerColor = rgb(hueInner);
    vOuterColor = vec4(rgb(hueInner + aColor.g), aColor.a);
    //gl_Position = uModelViewProjectionMatrix * vec4(aPosition, 1.0);
    gl_Position = uModelViewProjectionMatrix * vec4(position + aNormal, 1.0);
}
