//Attribute Position3F_Normal3F_TexCoord2F_Color4B_Data4B

//TechniqueParameter double _absoluteDistance //Default 0.0f

uniform mat4  uModelViewProjectionMatrix;
uniform float uHueShift;        //Default 0.0f
uniform float uHueMultiplier;   //Default 1.0f
uniform float uBeat;            //Default 0.0f

//CalculatedMaterial
uniform float uAbsoluteDistance; //Calculate _absoluteDistance

varying vec2 vTexCoord;
varying vec3 vInnerColor;
varying vec4 vOuterColor;

const float FULL = 255.0;
const float QUARTER = 63.75;

vec3 rgb(float h) { return clamp(abs(fract(h + vec3(3.0, 2.0, 1.0) / 3.0) * 6.0 - 3.0) - 1.0, 0.0, 1.0); }

void main()
{
    //AttributeMapping
    //aNormal  => MovingDirection
    //aColor.r => Hue
    //aColor.g => HueShiftOuter
    //aColor.b => UNUSED
    //aColor.a => Alpha
    //aData.x  => AnimationOffset
    //aData.y  => AnimationLength
    //aData.z  => AnimationFalloff
    //aData.w  => AnimationQuarterDistance
    
    float hueInner = aColor.r * uHueMultiplier + uHueShift;
    vTexCoord = aTexCoord;
    vInnerColor = rgb(hueInner);
    vOuterColor = vec4(rgb(hueInner + aColor.g), max(sign(uBeat - FULL * aData.x), 0.0) * (1.0 - clamp((uBeat - FULL * (aData.x + aData.y - aData.z)) / (FULL * aData.z), 0.0, 1.0)) * aColor.a);
    gl_Position = uModelViewProjectionMatrix * vec4(aPosition + aNormal * (max(0.0, uBeat - FULL * aData.x) * QUARTER * aData.w), 1.0);
}
